// Fragment shader for "cosmic" pins in PBA Challenge
// Copyright 2012 Concrete Software. All rights reserved.

// Direction of the main light in eye coordinates. Must be normalized.
uniform mediump vec3 pba_KeyLightPosition;
// values for "Rim" light on side to bring out shape
uniform mediump vec3 pba_RimLightPosition;
//uniform lowp float pba_RimShininess;
// color (and intensity) for the diffuse light
uniform mediump vec3 pba_diffuseColor;
// color (and intensity) for the ambient light
uniform mediump vec3 pba_ambientColor;

varying mediump vec3 var_Normal;

void main()
{
	mediump vec3 normalizedNormal = normalize(var_Normal);
	mediump float diffuseIntensity = max(dot(normalizedNormal, pba_KeyLightPosition), 0.0);
	diffuseIntensity += max(dot(normalizedNormal, pba_RimLightPosition), 0.0);

	gl_FragColor = vec4((pba_ambientColor + pba_diffuseColor * diffuseIntensity), 1.0);
}
