// Fragment shader for "cosmic" pins in PBA Challenge
// Copyright 2012 Concrete Software. All rights reserved.

// Direction of the main light in eye coordinates. Must be normalized.
uniform mediump vec3 pba_KeyLightPosition;
// values for "Rim" light on side to bring out shape
uniform mediump vec3 pba_RimLightPosition;

varying mediump vec3 var_Normal;
varying mediump vec3 var_Color;

void main()
{
	mediump vec3 normalizedNormal = normalize(var_Normal);
    // color (and intensity) for the ambient light
    mediump vec3 ambientColor = vec3(0.35) * var_Color;
	mediump float diffuseIntensity = max(dot(normalizedNormal, pba_KeyLightPosition), 0.0);
	diffuseIntensity += max(dot(normalizedNormal, pba_RimLightPosition), 0.0);

	gl_FragColor = vec4((ambientColor + var_Color * diffuseIntensity), 1.0);
}
