// Per-pixel lighting shader for PBA Challenge
// Copyright 2012 Concrete Software. All rights reserved.

uniform mat4 cs_ModelViewProjectionMatrix;
// Model view matrix without projection multiplied in. Needed for specular lighting.
uniform mat4 cs_ModelViewMatrix;
uniform mat3 cs_NormalMatrix;

attribute vec4 cs_Vertex;
attribute vec3 cs_Normal;
attribute vec2 cs_MultiTexCoord0;

varying lowp vec3 var_Normal;
varying lowp vec3 var_TransformedVertex;
varying mediump vec2 var_TexCoord;

void main()
{
	var_Normal = cs_NormalMatrix * cs_Normal;	
	var_TexCoord = cs_MultiTexCoord0.xy;
    var_TransformedVertex = (cs_ModelViewMatrix * cs_Vertex).xyz;
	gl_Position = cs_ModelViewProjectionMatrix * cs_Vertex;
}